PImage img;
int XMAX=320;
int YMAX=240;
int RMAX=100;
int THETA_MAX=1024;
int RHO_MAX=400;
int X0=10;
int Y0=10;
int X1=340;
int Y1=260;

float PIK=(float)PI/THETA_MAX;
byte[][] data=new byte[YMAX][XMAX];
float[] sn=new float[THETA_MAX];;
float[] cs=new float[THETA_MAX];
int[][] diagonal=new int[YMAX][XMAX];
int[][] counter=new int[THETA_MAX][2*RHO_MAX];

int centerX,centerY,distX,distY,rds,x,y;
int[][][] counter1=new int[YMAX][XMAX][RMAX];

void setup(){
  colorMode(RGB,255);
  img = loadImage("sample.gif");
  size(1024,800);
  image(img, X0,Y0);
    //三角関数テーブルを作成
    for(int i=0;i<THETA_MAX;i++){
      sn[i]=(float)Math.sin(PIK*i);
      cs[i]=(float)Math.cos(PIK*i);
  }

  //斜線長テーブルを作成
  for(y=0;y<YMAX;y++){
    for(x=0;x<XMAX;x++){
      diagonal[y][x]=(short)(Math.sqrt(y*y+x*x)+0.5);
      //img画像を二次元配列data[y][x]に変換する
      if (get(x,y)==color(0,0,0)) data[y][x]=1; else data[y][x]=0;
    }
  }
  noStroke();
  fill(255);
  rect(340,10,320,240); 
  lineHough();
  ellipseHough();

  ellipseRevHough();
  lineRevHough();
}

void lineHough(){
    //直線の場合 -------------------------------------------------
    int theta,rho;
    //直線検出用頻度カウンタ

    for(y=0;y<YMAX;y++){
        for(x=0;x<XMAX;x++){
              if(data[y][x]==1){
                 for(theta=0;theta<THETA_MAX;theta++){
                    rho=(int)(x*cs[theta]+y*sn[theta]+0.5);
                    counter[theta][rho+RHO_MAX]++;
                 }
              }
        }
    }
  
 }
   
 void ellipseHough(){
      //円の場合 ---------------------------------------------------
    for(y=0;y<YMAX;y++){
       for(x=0;x<XMAX;x++){
          if(data[y][x]==1){
             for(centerY=0;centerY<YMAX;centerY++){
                 distY=Math.abs(y-centerY);
                 if(distY<=RMAX) {
                   for(centerX=0;centerX<XMAX;centerX++){
                     distX=Math.abs(x-centerX);
                     rds=diagonal[distY][distX];
                     if(rds<RMAX) counter1[centerY][centerX][rds]++;
                   }
                 }
             }
          }
       }
    }
 }
   
   
 void lineRevHough(){
   //直線の場合 -------------------------------------------------
    int counter_max;
    int theta_max=0;
    int rho_max=-RHO_MAX;

    color c=color(255,0,0);

    int end_flag=0;
    int count=0;

    while(end_flag==0 && count<10){
       count++;
       counter_max=0;         
       //counterが最大になるtheta_maxとrho_maxを求める
       for(int theta=0;theta<THETA_MAX;theta++){
          for(int rho=-RHO_MAX;rho<RHO_MAX;rho++){
             if(counter[theta][rho+RHO_MAX]>counter_max){
                counter_max=counter[theta][rho+RHO_MAX];
                //60ピクセル以下の直線になれば検出を終了
                if(counter_max<=55) {
                  end_flag=1;
                } else {
                  end_flag=0;
                  theta_max=theta;
                  rho_max=rho;
                }
             }
          }
       }

       //検出した直線の描画
       //xを変化させてyを描く（垂直の線を除く）
       if(theta_max!=0){
          for(x=0;x<XMAX;x++){
             y=(int)((rho_max-x*cs[theta_max])/sn[theta_max]);
             if(y<YMAX && y>=0) set(X1+x,Y0+y,c);            
          }
       }

       //yを変化させてxを描く（水平の線を除く）
       if(theta_max!=THETA_MAX/2){
          for(y=0;y<YMAX;y++){
             x=(int)((rho_max-y*sn[theta_max])/cs[theta_max]);
             if(x<XMAX && x>=0) set(X1+x,Y0+y,c);
          }
       }

       //近傍の直線を消す
       for(int j=-10;j<=10;j++){
          for(int i=-30;i<=30;i++){
             if(theta_max+i<0){
                theta_max+=THETA_MAX;
                rho_max=-rho_max;
             }
             if(theta_max+i>=THETA_MAX){
                theta_max-=THETA_MAX;
                rho_max=-rho_max;
             }
             if(rho_max+j>=-RHO_MAX && rho_max+j<RHO_MAX)
             counter[theta_max+i][rho_max+RHO_MAX+j]=0;
          }
       }
    //長さが60ピクセル以下か、直線が10本検出されたら終了
    }
 
 }
 
 void ellipseRevHough(){
   //円の場合 ---------------------------------------------------
    int counter1_max;

    int centerX_max=0;
    int centerY_max=0;
    int radius_max=0;

    color c=color(0,0,255);

    int end_flag=0;
    int count=0;
    rectMode(CENTER);
    while(end_flag==0 && count<5){
       count++;
       counter1_max=0;         
       //counter1が最大になるcenterX_max、
       //centerY_maxとradius_maxを求める
       for(centerY=0;centerY<YMAX;centerY++){
          for(centerX=0;centerX<XMAX;centerX++){
             for(rds=0;rds<RMAX;rds++)
             if(counter1[centerY][centerX][rds]>counter1_max){
                counter1_max=counter1[centerY][centerX][rds];
                //100ピクセル以下の円になれば検出を終了
                if(counter1_max<=100) {
                  end_flag=1;
                } else {
                  end_flag=0;
                  centerY_max=centerY;
                  centerX_max=centerX;
                  radius_max=rds;
                }

             }
          }
       }

       //近傍の円を消す
       for(int k=-5;k<=5;k++){
          if(centerY_max+k<YMAX && centerY_max+k>=0){
            for(int j=-5;j<=5;j++){
               if(centerX_max+j<XMAX && centerX_max+j>=0) {
                   for(int i=-5;i<=5;i++){
                      if(radius_max+i<RMAX && radius_max+i>=0) counter1[centerY_max+k][centerX_max+j][radius_max+i]=0;
                   }
               }
            }
          }
       }          

       //検出した円の描画
       stroke(c);
       noFill();
       ellipse(X1+centerX_max,
         Y0+centerY_max,radius_max*2,radius_max*2);
       
    //大きさが100ピクセル以下か、円が5個検出されたら終了
    }   
 }
   

